/*
** Copyright (C) 2003-2005 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef INCLUDED_DIALOGSELECTSTYLE_H
#define INCLUDED_DIALOGSELECTSTYLE_H


#include "configuration.h"
#include <gtk/gtk.h>
#include "style.h"
#include "usfmtools.h"


enum UpdateGuiEvent {ugeUpDown, ugeLeft, ugeRight, ugeClick};


class SelectStyleDialog
{
public:
  SelectStyleDialog (const string& stylesheet, const string& style);
  virtual ~SelectStyleDialog ();
  virtual int run ();
  string selected_style;
protected:
  GtkWidget *selectstyledialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *table2;
  GtkWidget *treeview_identification;
  GtkWidget *treeview_introduction;
  GtkWidget *treeview_introduction2;
  GtkWidget *treeview_titles;
  GtkWidget *treeview_titles2;
  GtkWidget *treeview_chapters_verses;
  GtkWidget *treeview_paragraphs;
  GtkWidget *treeview_poetry;
  GtkWidget *treeview_tables;
  GtkWidget *treeview_footnotes;
  GtkWidget *treeview_crossreference;
  GtkWidget *treeview_study;
  GtkWidget *treeview_special_styles;
  GtkWidget *treeview_special_styles2;
  GtkWidget *treeview_peripheral;
  GtkWidget *treeview_other;
  GtkWidget *label33;
  GtkWidget *label34;
  GtkWidget *label35;
  GtkWidget *label36;
  GtkWidget *label37;
  GtkWidget *label38;
  GtkWidget *label45;
  GtkWidget *label39;
  GtkWidget *label40;
  GtkWidget *label41;
  GtkWidget *label42;
  GtkWidget *label43;
  GtkWidget *label44;
  GtkWidget *labelname;
  GtkWidget *scrolledwindow14;
  GtkWidget *textview1;
  GtkWidget *dialog_action_area1;
  GtkWidget *cancelbutton1;
  GtkWidget *okbutton;
  vector<Style> styles;  
  GtkListStore *store_identification;
  GtkListStore *store_introduction;
  GtkListStore *store_introduction2;
  GtkListStore *store_titles;
  GtkListStore *store_titles2;
  GtkListStore *store_chapters_verses;
  GtkListStore *store_paragraphs;
  GtkListStore *store_poetry;
  GtkListStore *store_tables;
  GtkListStore *store_footnotes;
  GtkListStore *store_crossreference;
  GtkListStore *store_study;
  GtkListStore *store_special_styles;
  GtkListStore *store_special_styles2;
  GtkListStore *store_peripheral;
  GtkListStore *store_other;
  GtkTreeViewColumn *column_identification;
  GtkTreeViewColumn *column_introduction;
  GtkTreeViewColumn *column_introduction2;
  GtkTreeViewColumn *column_titles;
  GtkTreeViewColumn *column_titles2;
  GtkTreeViewColumn *column_chapters_verses;
  GtkTreeViewColumn *column_paragraphs;
  GtkTreeViewColumn *column_poetry;
  GtkTreeViewColumn *column_tables;
  GtkTreeViewColumn *column_footnotes;
  GtkTreeViewColumn *column_crossreference;
  GtkTreeViewColumn *column_study;
  GtkTreeViewColumn *column_special_styles;
  GtkTreeViewColumn *column_special_styles2;
  GtkTreeViewColumn *column_peripheral;
  GtkTreeViewColumn *column_other;
  GtkTreeSelection *select_identification;
  GtkTreeSelection *select_introduction;
  GtkTreeSelection *select_introduction2;
  GtkTreeSelection *select_titles;
  GtkTreeSelection *select_titles2;
  GtkTreeSelection *select_chapters_verses;
  GtkTreeSelection *select_paragraphs;
  GtkTreeSelection *select_poetry;
  GtkTreeSelection *select_tables;
  GtkTreeSelection *select_footnotes;
  GtkTreeSelection *select_crossreference;
  GtkTreeSelection *select_study;
  GtkTreeSelection *select_special_styles;
  GtkTreeSelection *select_special_styles2;
  GtkTreeSelection *select_peripheral;
  GtkTreeSelection *select_other;
  static gboolean on_treeview_button_press_event (GtkWidget *widget, GdkEventButton *event, gpointer user_data);
  virtual gboolean on_treeview_button (GtkWidget * widget, GdkEventButton * event);
  static gboolean on_treeview_key_press_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data);
  virtual gboolean on_treeview_key (GtkWidget *widget, GdkEventKey *event);
  static void on_okbutton_clicked (GtkButton * button, gpointer user_data);
  virtual void on_ok_clicked ();
  static void selection_foreach_function (GtkTreeModel * model, GtkTreePath * path, GtkTreeIter * iter, gpointer data);
  virtual void get_selected_markers ();
  vector<string> currently_selected_markers;
  string currently_selected_marker;
  string previously_selected_marker;
  static bool on_update_gui (gpointer data);
  virtual void update_gui ();
  UpdateGuiEvent update_gui_event;
  GtkTreeSelection * get_selection (UsfmCategories category);
  GtkListStore * get_store (UsfmCategories category);
  virtual void select_marker (const string& marker);
  virtual void select_marker (GtkTreeModel *store, GtkTreeSelection * selection, GtkWidget * widget, const string& marker);
  virtual void get_markers (GtkTreeModel *store, vector<string>& markers);
  virtual bool get_next_category (UsfmCategories& category, bool next);
};


#endif
