/*
** Copyright (C) 2003-2005 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef INCLUDED_DIALOGSTYLESHEET_H
#define INCLUDED_DIALOGSTYLESHEET_H


#include <gtk/gtk.h>
#include "configuration.h"
#include "dialogselectstyle.h"


#define TEMPORAL_STYLESHEET "__temporal_stylesheet__"


class StylesheetDialog
{
public:
  StylesheetDialog (Configuration * configuration, const string& name);
  virtual ~ StylesheetDialog ();
  virtual int run ();
protected:
  string sheetname;
  string currentmarker;
  Configuration * myconfiguration;
private:
  GtkWidget *stylesheetdialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *hbox1;
  GtkWidget *label6;
  GtkWidget *labelstyle;
  GtkWidget *buttonselect;
  GtkWidget *alignment1;
  GtkWidget *hbox7;
  GtkWidget *image1;
  GtkWidget *label33;
  GtkWidget *button_new;
  GtkWidget *button_delete;
  GtkWidget *label37;
  GtkWidget *entryname;
  GtkWidget *label36;
  GtkWidget *scrolledwindow1;
  GtkWidget *textview1;
  GtkWidget *hseparator1;
  GtkWidget *hbox8;
  GtkWidget *vbox5;
  GtkWidget *label21;
  GtkWidget *vbox3;
  GtkWidget *radiobutton_id;
  GtkWidget *radiobutton_comment;
  GtkWidget *radiobutton_runningheader;
  GtkWidget *radiobutton_paragraph;
  GtkWidget *radiobutton_inline;
  GtkWidget *radiobutton_chapter;
  GtkWidget *radiobutton_verse;
  GtkWidget *vseparator1;
  GtkWidget *vbox6;
  GtkWidget *notebookfontsize;
  GtkWidget *hbox2;
  GtkWidget *label8;
  GtkObject *spinbuttonfontsize_adj;
  GtkWidget *spinbuttonfontsize;
  GtkWidget *label9;
  GtkWidget *label22;
  GtkWidget *hbox6;
  GtkWidget *label31;
  GtkObject *spinbuttonfontpercentage_adj;
  GtkWidget *spinbuttonfontpercentage;
  GtkWidget *label32;
  GtkWidget *label23;
  GtkWidget *empty_notebook_page;
  GtkWidget *label30;
  GtkWidget *notebook_italics_bold_underline_small_caps;
  GtkWidget *vbox7;
  GtkWidget *checkbutton_italic;
  GtkWidget *checkbutton_bold;
  GtkWidget *checkbutton_underline;
  GtkWidget *checkbutton_small_caps;
  GtkWidget *table2;
  GtkWidget *label40;
  GtkWidget *label41;
  GtkWidget *label42;
  GtkWidget *label_small_caps;
  GtkWidget *radiobutton_italics_off;
  GtkWidget *radiobutton_italics_on;
  GtkWidget *radiobutton_italics_inherit;
  GtkWidget *radiobutton_italics_toggle;
  GtkWidget *radiobutton_bold_off;
  GtkWidget *radiobutton_bold_on;
  GtkWidget *radiobutton_bold_inherit;
  GtkWidget *radiobutton_bold_toggle;
  GtkWidget *radiobutton_underline_off;
  GtkWidget *radiobutton_underline_on;
  GtkWidget *radiobutton_underline_inherit;
  GtkWidget *radiobutton_underline_toggle;
  GtkWidget *radiobutton_small_caps_off;
  GtkWidget *radiobutton_small_caps_on;
  GtkWidget *radiobutton_small_caps_inherit;
  GtkWidget *radiobutton_small_caps_toggle;
  GtkWidget *notebook_superscript;
  GtkWidget *checkbutton_superscript;
  GtkWidget *label28;
  GtkWidget *label29;
  GtkWidget *notebook_paragraph;
  GtkWidget *vbox4;
  GtkWidget *hbox4;
  GtkWidget *label10;
  GtkWidget *radiobutton_left;
  GtkWidget *radiobutton_center;
  GtkWidget *radiobutton_right;
  GtkWidget *radiobutton_full;
  GtkWidget *table1;
  GtkWidget *label11;
  GtkWidget *label12;
  GtkWidget *label13;
  GtkWidget *label14;
  GtkWidget *label15;
  GtkWidget *label16;
  GtkWidget *label17;
  GtkWidget *label18;
  GtkWidget *label19;
  GtkWidget *label20;
  GtkObject *spinbutton_first_adj;
  GtkWidget *spinbutton_first;
  GtkObject *spinbutton_before_adj;
  GtkWidget *spinbutton_before;
  GtkObject *spinbutton_after_adj;
  GtkWidget *spinbutton_after;
  GtkObject *spinbutton_left_adj;
  GtkWidget *spinbutton_left;
  GtkObject *spinbutton_right_adj;
  GtkWidget *spinbutton_right;
  GtkWidget *checkbutton_span;
  GtkWidget *label38;
  GtkWidget *label39;
  GtkWidget *dialog_action_area1;
  GtkWidget *cancelbutton1;
  GtkWidget *okbutton;
  static void on_buttonselect_clicked (GtkButton *button, gpointer user_data);
  virtual void on_select ();
  static void on_button_new_clicked (GtkButton *button, gpointer user_data);
  virtual void on_new();
  static void on_button_delete_clicked (GtkButton *button, gpointer user_data);
  virtual void on_delete();
  static void on_okbutton_clicked (GtkButton *button, gpointer user_data);
  virtual void on_ok();
  static void on_style_type_toggled (GtkToggleButton *togglebutton, gpointer user_data);
  virtual void on_style_type (GtkToggleButton *togglebutton);
  static void on_alignment_toggled (GtkToggleButton *togglebutton, gpointer user_data);
  virtual void on_alignment (GtkToggleButton *togglebutton);
  virtual void set_gui (const string& select);
  virtual void save_style ();
  virtual void set_justification (const string& justification);
  virtual string get_justification ();
  virtual void set_italic (const string& italic);
  virtual string get_italic ();
  virtual void set_bold (const string& bold);
  virtual string get_bold ();
  virtual void set_underline (const string& underline);
  virtual string get_underline ();
  virtual void set_small_caps (const string& small_caps);
  virtual string get_small_caps ();
  virtual StyleType get_styletype ();
  static void on_radiobutton_italic_toggled (GtkToggleButton *togglebutton, gpointer user_data);
  virtual void on_radiobutton_italic (GtkWidget *togglebutton);
  static void on_radiobutton_bold_toggled (GtkToggleButton *togglebutton, gpointer user_data);
  virtual void on_radiobutton_bold (GtkWidget *togglebutton);
  static void on_radiobutton_underline_toggled (GtkToggleButton *togglebutton, gpointer user_data);
  virtual void on_radiobutton_underline (GtkWidget *togglebutton);
  static void on_radiobutton_small_caps_toggled (GtkToggleButton *togglebutton, gpointer user_data);
  virtual void on_radiobutton_small_caps (GtkWidget *togglebutton);
};


#endif
