/*
** Copyright (C) 2003-2005 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#include "libraries.h"
#include "utilities.h"
#include <libgen.h>
#include <glib.h>
#include <config.h>
#include "formatter.h"
#include "fop.h"
#include "xep.h"
#include "xslformatter.h"


bool formatter_present (GtkWidget * window, Configuration * configuration)
// Returns whether a script to run a formatter can be found.
// Gives message if not found.
{
  switch (configuration->formatter_of_choice) {
    case ffcFOP          : return fop_present          (window, configuration);
    case ffcXEP          : return xep_present          (window, configuration);
    case ffcXSLFormatter : return xslformatter_present (window, configuration);
  }
  return false;
}


int formatter_convert_to_pdf (Configuration * configuration, const string& xslfo, const string& pdf)
// Converts file "xslfo" to file "pdf", and returns the result.
{
  switch (configuration->formatter_of_choice) {
    case ffcFOP          : return fop_convert_to_pdf          (configuration, xslfo, pdf);
    case ffcXEP          : return xep_convert_to_pdf          (configuration, xslfo, pdf);
    case ffcXSLFormatter : return xslformatter_convert_to_pdf (configuration, xslfo, pdf);
  }
  return -1;
}
