/*
** Copyright (C) 2003-2005 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#include "libraries.h"
#include "utilities.h"
#include "worddatabase.h"
#include <config.h>
#include "log.h"
#include <glib.h>
#include "indexstorage.h"


IndexStorage::IndexStorage (const string& project_in, const string& filename_in)
{
  type = isCheckBook;
  project = project_in;
  filename = filename_in;
  initialize ();
}


IndexStorage::IndexStorage (const string& project_in, unsigned int book_in, unsigned int chapter_in, const vector <ustring>& lines_in)
{
  type = isIndexChapter;
  project = project_in;
  book = book_in;
  chapter = chapter_in;
  lines.assign (lines_in.begin(), lines_in.end());
  initialize ();
}


IndexStorage::IndexStorage (const string& project_in, const string& filename_in, const string& signature_in)
{
  type = isStoreSignature;
  project = project_in;
  filename = filename_in;
  signature = signature_in;
  initialize ();
}


IndexStorage::~IndexStorage ()
{
}


void IndexStorage::initialize ()
{
  beingdone = false;
  done = false;
}
