/*
** Copyright (C) 2003-2005 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#include "libraries.h"
#include "utilities.h"
#include <libgen.h>
#include <glib.h>
#include <config.h>
#include "splashscreen.h"


static GtkWidget * splashscreenwindow;


void splashscreen_init (const string& message)
{
  GtkWidget *fixed1;
  GtkWidget * splashscreenlabel;
  
  splashscreenwindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (splashscreenwindow), "Bibledit");
  gtk_window_set_position (GTK_WINDOW (splashscreenwindow), GTK_WIN_POS_CENTER);
  gtk_window_set_default_size (GTK_WINDOW (splashscreenwindow), 300, 100);
  gtk_window_set_skip_taskbar_hint (GTK_WINDOW (splashscreenwindow), TRUE);
  gtk_window_set_skip_pager_hint (GTK_WINDOW (splashscreenwindow), TRUE);
  gtk_window_set_type_hint (GTK_WINDOW (splashscreenwindow), GDK_WINDOW_TYPE_HINT_SPLASHSCREEN);
  gtk_window_set_gravity (GTK_WINDOW (splashscreenwindow), GDK_GRAVITY_CENTER);

  fixed1 = gtk_fixed_new ();
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (splashscreenwindow), fixed1);

  splashscreenlabel = gtk_label_new (message.c_str());
  gtk_widget_show (splashscreenlabel);
  gtk_fixed_put (GTK_FIXED (fixed1), splashscreenlabel, 8, 24);
  gtk_widget_set_size_request (splashscreenlabel, 280, 17);
  gtk_label_set_justify (GTK_LABEL (splashscreenlabel), GTK_JUSTIFY_CENTER);
  gtk_misc_set_alignment (GTK_MISC (splashscreenlabel), 0.5, 0);
  
  gtk_widget_show (splashscreenwindow);
  
  while (gtk_events_pending ()) gtk_main_iteration ();
  g_usleep (1000);
  while (gtk_events_pending ()) gtk_main_iteration ();
  g_usleep (1000);
  while (gtk_events_pending ()) gtk_main_iteration ();
}


void splashscreen_destroy ()
{
  gtk_widget_destroy (splashscreenwindow);
}
